<?php

namespace App\Http\Controllers\Api;


use App\Jobs\DesktopDeviceJob;
use App\Jobs\LabelDealJob;
use App\Jobs\ManDeviceJob;
use App\Jobs\ProcessDataJob;
use App\Model\BigKingCbj;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Redis;


class JobController extends BaseController
{
    //温度压力传感器设备
    public function processDataJobAdd(Request $request)
    {
        dispatch(new ProcessDataJob($request->all()))->onQueue('cloud_device');
        echo 'ok';
    }

    //桌面设备
    public function processDataJobAddDevice(Request $request){
        dispatch(new DesktopDeviceJob($request->all()))->onQueue('desktop_device');
        echo 'ok';
    }

    //有人云
    public function processDataJobAddDeviceMan(Request $request){
        dispatch(new ManDeviceJob($request->all()))->onQueue('man_device');

        echo $request->get('verify');die;
    }

    public function delKey(Request $request){return;
        $token_key = 'big_king_login_token';
//        $token = Redis::get($token_key);
        Redis::del($token_key);
    }

    public function labelDeal(Request $request){
        //记录数据
        $model = new BigKingCbj();
        $model->data = json_encode($request->all());
        $model->crt_time = time();
        $model->save();
        $id = $model->id;

        $header = $request->header('Authorization');
        dispatch(new LabelDealJob($request->all(), $header, $id))->onQueue('label_deal');

        return ['status'=>200,'msg'=>'success'];
    }
}
