<?php

use Illuminate\Http\Request;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/

Route::middleware('auth:api')->get('/user', function (Request $request) {
    return $request->user();
});

//用于出标机开关门的redis
Route::any('openCommand', 'Api\DwyController@openCommand');
Route::any('getOpenCommand', 'Api\DwyController@getOpenCommand');
Route::any('openDoor', 'Api\DwyController@openDoor');
Route::any('setLb', 'Api\DwyController@setLb');
Route::any('boxList', 'Api\DwyController@boxList');
//Route::any('boxOut', 'Api\DwyController@boxOut');

//贴标机
Route::any('setTbData', 'Api\DwyController@setTbData');
Route::any('getTbData', 'Api\DwyController@getTbData');

Route::any('login', 'Api\LoginController@login');
Route::any('job', 'Api\JobController@processDataJobAdd');
Route::any('job_device', 'Api\JobController@processDataJobAddDevice');
Route::any('man_device', 'Api\JobController@processDataJobAddDeviceMan');
//通道门传输的数据保存单号
Route::any('setOrderNumber', 'Api\InOutOptionController@setOrderNumber');
//获取单号
Route::any('getOrderNumber', 'Api\InOutOptionController@getOrderNumber');
//设置发货出库标识
Route::any('setFhMessage', 'Api\InOutOptionController@setFhMessage');
Route::any('del', 'Api\JobController@delKey');
Route::any('oee', 'Api\ScreenController@oee');
Route::any('wyOee', 'Api\ScreenController@wyOee');
Route::any('wd', 'Api\ScreenController@wd');
Route::any('yl', 'Api\ScreenController@yl');
Route::any('gz', 'Api\ScreenController@gz');
Route::any('deviceAll', 'Api\ScreenController@deviceAll');
Route::any('deviceChart', 'Api\ScreenController@deviceChart');
Route::any('inout', 'Api\ScreenController@inout');
Route::any('upInout', 'Api\ScreenController@upInout');
Route::any('gzEchart', 'Api\ScreenController@gzEchart');
Route::any('t', 'Api\ScreenController@t');
Route::any('deviceCallback', 'Api\TestController@deviceCallback');
Route::any('advertisement', 'Api\DwyController@advertisement');
Route::any('zjlb', 'Api\DwyController@zjlb');
Route::any('tttt', 'Api\DwyController@tttt');
Route::any('getBoxTrademark', 'Api\DwyController@getBoxTrademark');
Route::any('aaaa', 'Api\DwyController@setBoxTrademark');
Route::any('boxOut', 'Api\JobController@labelDeal');

Route::group(['middleware'=> []],function ($route){
    $route->any('menuAdd', 'Api\SysMenuController@add');
    $route->any('menuEdit', 'Api\SysMenuController@edit');
    $route->any('menuDel', 'Api\SysMenuController@del');
    $route->any('menuList', 'Api\SysMenuController@menuList');

    $route->any('employeeAdd', 'Api\EmployeeController@employeeAdd');
    $route->any('employeeEdit', 'Api\EmployeeController@employeeEdit');
    $route->any('employeeDel', 'Api\EmployeeController@employeeDel');
    $route->any('employeeList', 'Api\EmployeeController@employeeList');

    $route->any('departAdd', 'Api\EmployeeController@departAdd');
    $route->any('departEdit', 'Api\EmployeeController@departEdit');
    $route->any('departDel', 'Api\EmployeeController@departDel');
    $route->any('departList', 'Api\EmployeeController@departList');

    $route->any('roleAdd', 'Api\EmployeeController@roleAdd');
    $route->any('roleEdit', 'Api\EmployeeController@roleEdit');
    $route->any('roleDel', 'Api\EmployeeController@roleDel');
    $route->any('roleList', 'Api\EmployeeController@roleList');

    $route->any('employeeDepart', 'Api\EmployeeController@employeeDepart');
    $route->any('employeeTeam', 'Api\EmployeeController@employeeTeam');
    $route->any('employeeRole', 'Api\EmployeeController@employeeRole');
});
